/*
 * TimerThread.h
 *
 *  Created on: 2010.08.07.
 *      Author: Karma
 */

#ifndef TIMERTHREAD_H_
#define TIMERTHREAD_H_

#include <FBase.h>

class TimerThread;

class ITimerThreadEventListener
{
public:
	virtual void OnTimerTick(TimerThread &thread) = 0;
};

class TimerThread : public Osp::Base::Runtime::Thread,
	public Osp::Base::Runtime::ITimerEventListener
{
public:
	TimerThread(ITimerThreadEventListener &observer, int timeout);
	result Construct();
	result Construct(Osp::Base::String name);
	virtual ~TimerThread();

public:
	bool OnStart();
	void OnStop();

private:
	void OnTimerExpired(Osp::Base::Runtime::Timer &timer);

private:
	ITimerThreadEventListener &__observer;
	int __timeout;
	Osp::Base::Runtime::Timer __timer;
};

#endif /* TIMERTHREAD_H_ */
