/*
 * TimerThread.cpp
 *
 *  Created on: 2010.08.07.
 *      Author: Karma
 */

#include "TimerThread.h"

using namespace Osp::Base;
using namespace Osp::Base::Runtime;

TimerThread::TimerThread(ITimerThreadEventListener &observer, int timeout) :
	__observer(observer), __timeout(timeout)
{
}

TimerThread::~TimerThread()
{
}

result
TimerThread::Construct(Osp::Base::String name)
{
	result r = E_SUCCESS;
	r = Thread::Construct(name, THREAD_TYPE_EVENT_DRIVEN);
	TryReturn(r == E_SUCCESS, r, "Thread Construct failed [%S]", GetErrorMessage(r));
	r = __timer.Construct(*this);
	TryReturn(r == E_SUCCESS, r, "TimerConstruct failed [%S]", GetErrorMessage(r));
	return r;
}

result
TimerThread::Construct()
{
	return Construct(L"TimerThread");
}

bool
TimerThread::OnStart()
{
	__timer.Start(__timeout);
	return true;
}

void
TimerThread::OnStop()
{
	__timer.Cancel();
}

void
TimerThread::OnTimerExpired(Osp::Base::Runtime::Timer &timer)
{
	__observer.OnTimerTick(*this);
	__timer.Start(__timeout);
}
